<script lang="ts">
  import { IntercomColorsMap } from '$lib/constants/intercom';
  import Fa from 'svelte-fa';
  import { faTimes } from '@fortawesome/free-solid-svg-icons';
  // import countdown from 'countdown';
  import { onMount } from 'svelte';

  // let intercom: Intercom;
  let enabled = false;
  let message = '';
  let intercomColor: IntercomColorsMap = IntercomColorsMap.green;
  let countdownEventId: number | null = null;
  let eventStartDate: Date;
  let formattedTime = '';

  // function parseMessage(message: string): { eventId: number | null; message: string } {
  //   // const countdownPattern = /^(.*),\s*countdown\((\d+)\)$/;
  //   // const match = message.match(countdownPattern);
  //   //
  //   // if (match && match[2]) {
  //   //   return {
  //   //     eventId: parseInt(match[2], 10),
  //   //     message: match[1].trim()
  //   //   };
  //   // }
  //
  //   return { eventId: null, message };
  // }

  // async function getIntercomData() {
  //   intercom = await getIntercom();
  //   message = intercom.message;
  //   if (message.length > 0) {
  //     intercomColor = IntercomColorsMap[intercom.intercom_color as keyof typeof IntercomColorsMap];
  //     enabled = intercom.enabled;
  //   }
  // }
  async function prepareIntercom() {
    // todo re-implement intercom
    // await getIntercomData();
    // const parsedData = parseMessage(message);
    // message = parsedData.message;
    // countdownEventId = parsedData.eventId;
    //
    // if (countdownEventId !== null) {
    //   await getEventById(countdownEventId).then((res) => {
    //     eventStartDate = new Date(res.start);
    //   });
    // }
  }

  function startCountdown() {
    // if (countdownEventId !== null && eventStartDate) {
    //   // @ts-ignore the countdown library kind of sucks, and this isn't typed as callable
    //   countdown(
    //     eventStartDate,
    //     // @ts-ignore not sure what this type is
    //     (ts) => {
    //       formattedTime = ts.toString();
    //     },
    //     countdown.DAYS | countdown.HOURS | countdown.MINUTES | countdown.SECONDS
    //   );
    // }
  }

  onMount(prepareIntercom);

  $: if (countdownEventId !== null && eventStartDate) {
    startCountdown();
  }
</script>

<!-- Desktop -->
{#if enabled}
  <header class="hidden xl:block sticky top-20 z-40">
    <nav class="flex flex-row {intercomColor} px-5 h-15">
      <div class="flex-none mt-4 cursor-pointer" on:click={() => (enabled = false)}>
        <Fa class="mr-1.5" icon={faTimes} size="lg" />
      </div>
      <div class="flex flex-grow justify-center py-4 mr-4 text-zinc-900">
        <div>
          {message}{countdownEventId !== null ? ` ${formattedTime}` : ''}
        </div>
      </div>
    </nav>
  </header>
{/if}

<!-- Mobile -->
{#if enabled}
  <header class="xl:hidden sticky top-16 z-40">
    <div class="flex h-16 justify-start items-center {intercomColor} px-4 z-20">
      <div class="flex-none self-center" on:click={() => (enabled = false)}>
        <Fa class="mr-1.5" icon={faTimes} size="lg" />
      </div>
      <div class="py-4 mr-4 flex-shrink-0">
        <p class="flex self-center text-zinc-900">
          {message}{countdownEventId !== null ? ` ${formattedTime}` : ''}
        </p>
      </div>
    </div>
  </header>
{/if}
